/*
 * SpaceEx2Boogie v1.0
 * Hybrid Automaton in Boogie
 */
// Initial State: ~SX2B.currentLocation == 1 && buckboost.buckboost_template_1.il == 0.0 && buckboost.buckboost_template_1.vc == 0.0 && buckboost.buckboost_template_1.t == 0.0 && buckboost.buckboost_template_1.gt == 0.0

procedure SpaceExAutomaton()
{
	// Vars
	var ~SX2B.time : real;
	var ~SX2B.currentLocation : int;
	var ~SX2B.initialLocationFlag : bool;
	var buckboost.buckboost_template_1.il : real;
	var buckboost.buckboost_template_1.il.new : real;
	var buckboost.buckboost_template_1.vc : real;
	var buckboost.buckboost_template_1.vc.new : real;
	var buckboost.buckboost_template_1.t : real;
	var buckboost.buckboost_template_1.t.new : real;
	var buckboost.buckboost_template_1.gt : real;
	var buckboost.buckboost_template_1.gt.new : real;

	// Initial value assignments
	~SX2B.initialLocationFlag := true;

	// Constants
	// var buckboost.buckboost_template_1.a00o : real = (0.0-196.2264);
	// var buckboost.buckboost_template_1.a01o : real = (0.0-377.3585);
	// var buckboost.buckboost_template_1.a10o : real = 454.5455;
	// var buckboost.buckboost_template_1.a11o : real = (0.0-45.4545);
	// var buckboost.buckboost_template_1.a00c : real = (0.0-1516.9811);
	// var buckboost.buckboost_template_1.a01c : real = (0.0-377.3585);
	// var buckboost.buckboost_template_1.a10c : real = 454.5455;
	// var buckboost.buckboost_template_1.a11c : real = (0.0-45.4545);
	// var buckboost.buckboost_template_1.bounds : real = 1000.0;
	// var buckboost.buckboost_template_1.T : real = 0.000016667;
	// var buckboost.buckboost_template_1.D : real = 0.6072;
	// var buckboost.buckboost_template_1.b0o : real = 0.0;
	// var buckboost.buckboost_template_1.b1o : real = 0.0;
	// var buckboost.buckboost_template_1.b0c : real = 377.3585;
	// var buckboost.buckboost_template_1.b1c : real = 0.0;
	// var buckboost.buckboost_template_1.Vs : real = 100.0;
	// var buckboost.buckboost_template_1.tmax : real = 0.03;
	// var ~SX2B.timeHorizon : real = 1.0;

	// Initial Location Jumps
	if (*) { goto buckboost.buckboost_template_1.charging; }
	if (*) { goto buckboost.buckboost_template_1.discontinuous; }
	if (*) { goto buckboost.buckboost_template_1.discharging; }
	goto ~SX2B.end;

	// Locations
buckboost.buckboost_template_1.charging:
	~SX2B.currentLocation := 1;
	if (~SX2B.initialLocationFlag) {
		assume (~SX2B.currentLocation == 1 && buckboost.buckboost_template_1.il == 0.0 && buckboost.buckboost_template_1.vc == 0.0 && 0.0 == 0.0 && buckboost.buckboost_template_1.gt == 0.0);
		~SX2B.initialLocationFlag := false;
	}
	havoc ~SX2B.time;
	assume (~SX2B.time >= 0.0 && ~SX2B.time <= 1.0); // ~SX2B.timeHorizon
	// flow
	// buckboost.buckboost_template_1.il := buckboost.buckboost_template_1.il + ~SX2B.time * (buckboost.buckboost_template_1.a00c * buckboost.buckboost_template_1.il + buckboost.buckboost_template_1.a01c * buckboost.buckboost_template_1.vc + buckboost.buckboost_template_1.b0c * buckboost.buckboost_template_1.Vs);
	buckboost.buckboost_template_1.il := buckboost.buckboost_template_1.il + ~SX2B.time * ((0.0-1516.9811) * buckboost.buckboost_template_1.il + (0.0-377.3585) * buckboost.buckboost_template_1.vc + 377.3585 * 100.0);
	// buckboost.buckboost_template_1.vc := buckboost.buckboost_template_1.vc + ~SX2B.time * (buckboost.buckboost_template_1.a10c * buckboost.buckboost_template_1.il + buckboost.buckboost_template_1.a11c * buckboost.buckboost_template_1.vc + buckboost.buckboost_template_1.b1c * buckboost.buckboost_template_1.Vs);
	buckboost.buckboost_template_1.vc := buckboost.buckboost_template_1.vc + ~SX2B.time * (454.5455 * buckboost.buckboost_template_1.il + (0.0-45.4545) * buckboost.buckboost_template_1.vc + 0.0 * 100.0);
	buckboost.buckboost_template_1.t := buckboost.buckboost_template_1.t + ~SX2B.time * 1.0;
	buckboost.buckboost_template_1.gt := buckboost.buckboost_template_1.gt + ~SX2B.time * 1.0;
	// invariant
	// assume (buckboost.buckboost_template_1.t >= 0.0 && buckboost.buckboost_template_1.t <= buckboost.buckboost_template_1.D * buckboost.buckboost_template_1.T && buckboost.buckboost_template_1.gt >= 0.0 && buckboost.buckboost_template_1.gt <= buckboost.buckboost_template_1.tmax && buckboost.buckboost_template_1.D >= 0.0 && buckboost.buckboost_template_1.D <= 1.0 && buckboost.buckboost_template_1.il >= 0.0 - buckboost.buckboost_template_1.bounds && buckboost.buckboost_template_1.il <= buckboost.buckboost_template_1.bounds && buckboost.buckboost_template_1.vc >= 0.0 - buckboost.buckboost_template_1.bounds && buckboost.buckboost_template_1.vc <= buckboost.buckboost_template_1.bounds);
	assume (0.000016667 >= 0.0 && 0.000016667 <= 0.6072 * 0.000016667 && buckboost.buckboost_template_1.gt >= 0.0 && buckboost.buckboost_template_1.gt <= 0.03 && 0.6072 >= 0.0 && 0.6072 <= 1.0 && buckboost.buckboost_template_1.il >= 0.0 - 1000.0 && buckboost.buckboost_template_1.il <= 1000.0 && buckboost.buckboost_template_1.vc >= 0.0 - 1000.0 && buckboost.buckboost_template_1.vc <= 1000.0);
	// transitions
	if (*) {
		// assume (buckboost.buckboost_template_1.t >= buckboost.buckboost_template_1.D * buckboost.buckboost_template_1.T);
		assume (0.000016667 >= 0.6072 * 0.000016667);
		// havoc new vars
		havoc buckboost.buckboost_template_1.t.new;
		havoc buckboost.buckboost_template_1.gt.new;
		havoc buckboost.buckboost_template_1.vc.new;
		havoc buckboost.buckboost_template_1.il.new;
		// assume assignment condition
		// assume (buckboost.buckboost_template_1.t.new == 0.0 && buckboost.buckboost_template_1.gt.new == buckboost.buckboost_template_1.gt && buckboost.buckboost_template_1.vc.new == buckboost.buckboost_template_1.vc && buckboost.buckboost_template_1.il.new == buckboost.buckboost_template_1.il);
		assume (0.000016667 == 0.0 && buckboost.buckboost_template_1.gt.new == buckboost.buckboost_template_1.gt && buckboost.buckboost_template_1.vc.new == buckboost.buckboost_template_1.vc && buckboost.buckboost_template_1.il.new == buckboost.buckboost_template_1.il);
		// assign new variable values
		buckboost.buckboost_template_1.t := buckboost.buckboost_template_1.t.new;
		buckboost.buckboost_template_1.gt := buckboost.buckboost_template_1.gt.new;
		buckboost.buckboost_template_1.vc := buckboost.buckboost_template_1.vc.new;
		buckboost.buckboost_template_1.il := buckboost.buckboost_template_1.il.new;
		goto buckboost.buckboost_template_1.discharging;
	}
	goto ~SX2B.end;

buckboost.buckboost_template_1.discontinuous:
	~SX2B.currentLocation := 2;
	if (~SX2B.initialLocationFlag) {
		assume (~SX2B.currentLocation == 1 && buckboost.buckboost_template_1.il == 0.0 && buckboost.buckboost_template_1.vc == 0.0 && 0.0 == 0.0 && buckboost.buckboost_template_1.gt == 0.0);
		~SX2B.initialLocationFlag := false;
	}
	havoc ~SX2B.time;
	assume (~SX2B.time >= 0.0 && ~SX2B.time <= 1.0); // ~SX2B.timeHorizon
	// flow
	buckboost.buckboost_template_1.il := buckboost.buckboost_template_1.il + ~SX2B.time * 0.0;
	// buckboost.buckboost_template_1.vc := buckboost.buckboost_template_1.vc + ~SX2B.time * (buckboost.buckboost_template_1.a11o * buckboost.buckboost_template_1.vc + buckboost.buckboost_template_1.b1o * buckboost.buckboost_template_1.Vs);
	buckboost.buckboost_template_1.vc := buckboost.buckboost_template_1.vc + ~SX2B.time * ((0.0-45.4545) * buckboost.buckboost_template_1.vc + 0.0 * 100.0);
	buckboost.buckboost_template_1.t := buckboost.buckboost_template_1.t + ~SX2B.time * 1.0;
	buckboost.buckboost_template_1.gt := buckboost.buckboost_template_1.gt + ~SX2B.time * 1.0;
	// invariant
	// assume (buckboost.buckboost_template_1.t >= 0.0 && buckboost.buckboost_template_1.t <= (1.0 - buckboost.buckboost_template_1.D) * buckboost.buckboost_template_1.T && buckboost.buckboost_template_1.gt >= 0.0 && buckboost.buckboost_template_1.gt <= buckboost.buckboost_template_1.tmax && buckboost.buckboost_template_1.D >= 0.0 && buckboost.buckboost_template_1.D <= 1.0 && buckboost.buckboost_template_1.vc >= 0.0 - buckboost.buckboost_template_1.bounds && buckboost.buckboost_template_1.vc <= buckboost.buckboost_template_1.bounds && buckboost.buckboost_template_1.il <= 0.0);
	assume (0.000016667 >= 0.0 && 0.000016667 <= (1.0 - 0.6072) * 0.000016667 && buckboost.buckboost_template_1.gt >= 0.0 && buckboost.buckboost_template_1.gt <= 0.03 && 0.6072 >= 0.0 && 0.6072 <= 1.0 && buckboost.buckboost_template_1.vc >= 0.0 - 1000.0 && buckboost.buckboost_template_1.vc <= 1000.0 && buckboost.buckboost_template_1.il <= 0.0);
	// transitions
	if (*) {
		// assume (buckboost.buckboost_template_1.t >= (1.0 - buckboost.buckboost_template_1.D) * buckboost.buckboost_template_1.T);
		assume (0.000016667 >= (1.0 - 0.6072) * 0.000016667);
		// havoc new vars
		havoc buckboost.buckboost_template_1.t.new;
		havoc buckboost.buckboost_template_1.gt.new;
		havoc buckboost.buckboost_template_1.vc.new;
		havoc buckboost.buckboost_template_1.il.new;
		// assume assignment condition
		// assume (buckboost.buckboost_template_1.t.new == 0.0 && buckboost.buckboost_template_1.gt.new == buckboost.buckboost_template_1.gt && buckboost.buckboost_template_1.vc.new == buckboost.buckboost_template_1.vc && buckboost.buckboost_template_1.il.new == buckboost.buckboost_template_1.il);
		assume (0.000016667 == 0.0 && buckboost.buckboost_template_1.gt.new == buckboost.buckboost_template_1.gt && buckboost.buckboost_template_1.vc.new == buckboost.buckboost_template_1.vc && buckboost.buckboost_template_1.il.new == buckboost.buckboost_template_1.il);
		// assign new variable values
		buckboost.buckboost_template_1.t := buckboost.buckboost_template_1.t.new;
		buckboost.buckboost_template_1.gt := buckboost.buckboost_template_1.gt.new;
		buckboost.buckboost_template_1.vc := buckboost.buckboost_template_1.vc.new;
		buckboost.buckboost_template_1.il := buckboost.buckboost_template_1.il.new;
		goto buckboost.buckboost_template_1.charging;
	}
	goto ~SX2B.end;

buckboost.buckboost_template_1.discharging:
	~SX2B.currentLocation := 3;
	if (~SX2B.initialLocationFlag) {
		assume (~SX2B.currentLocation == 1 && buckboost.buckboost_template_1.il == 0.0 && buckboost.buckboost_template_1.vc == 0.0 && 0.0 == 0.0 && buckboost.buckboost_template_1.gt == 0.0);
		~SX2B.initialLocationFlag := false;
	}
	havoc ~SX2B.time;
	assume (~SX2B.time >= 0.0 && ~SX2B.time <= 1.0); // ~SX2B.timeHorizon
	// flow
	// buckboost.buckboost_template_1.il := buckboost.buckboost_template_1.il + ~SX2B.time * (buckboost.buckboost_template_1.a00o * buckboost.buckboost_template_1.il + buckboost.buckboost_template_1.a01o * buckboost.buckboost_template_1.vc + buckboost.buckboost_template_1.b0o * buckboost.buckboost_template_1.Vs);
	buckboost.buckboost_template_1.il := buckboost.buckboost_template_1.il + ~SX2B.time * ((0.0-196.2264) * buckboost.buckboost_template_1.il + (0.0-377.3585) * buckboost.buckboost_template_1.vc + 0.0 * 100.0);
	// buckboost.buckboost_template_1.vc := buckboost.buckboost_template_1.vc + ~SX2B.time * (buckboost.buckboost_template_1.a10o * buckboost.buckboost_template_1.il + buckboost.buckboost_template_1.a11o * buckboost.buckboost_template_1.vc + buckboost.buckboost_template_1.b1o * buckboost.buckboost_template_1.Vs);
	buckboost.buckboost_template_1.vc := buckboost.buckboost_template_1.vc + ~SX2B.time * (454.5455 * buckboost.buckboost_template_1.il + (0.0-45.4545) * buckboost.buckboost_template_1.vc + 0.0 * 100.0);
	buckboost.buckboost_template_1.t := buckboost.buckboost_template_1.t + ~SX2B.time * 1.0;
	buckboost.buckboost_template_1.gt := buckboost.buckboost_template_1.gt + ~SX2B.time * 1.0;
	// invariant
	// assume (buckboost.buckboost_template_1.t >= 0.0 && buckboost.buckboost_template_1.t <= (1.0 - buckboost.buckboost_template_1.D) * buckboost.buckboost_template_1.T && buckboost.buckboost_template_1.gt >= 0.0 && buckboost.buckboost_template_1.gt <= buckboost.buckboost_template_1.tmax && buckboost.buckboost_template_1.D >= 0.0 && buckboost.buckboost_template_1.D <= 1.0 && buckboost.buckboost_template_1.vc >= 0.0 - buckboost.buckboost_template_1.bounds && buckboost.buckboost_template_1.vc <= buckboost.buckboost_template_1.bounds && buckboost.buckboost_template_1.il >= 0.0 - buckboost.buckboost_template_1.bounds && buckboost.buckboost_template_1.il <= buckboost.buckboost_template_1.bounds);
	assume (0.000016667 >= 0.0 && 0.000016667 <= (1.0 - 0.6072) * 0.000016667 && buckboost.buckboost_template_1.gt >= 0.0 && buckboost.buckboost_template_1.gt <= 0.03 && 0.6072 >= 0.0 && 0.6072 <= 1.0 && buckboost.buckboost_template_1.vc >= 0.0 - 1000.0 && buckboost.buckboost_template_1.vc <= 1000.0 && buckboost.buckboost_template_1.il >= 0.0 - 1000.0 && buckboost.buckboost_template_1.il <= 1000.0);
	// transitions
	if (*) {
		// assume (buckboost.buckboost_template_1.t >= (1.0 - buckboost.buckboost_template_1.D) * buckboost.buckboost_template_1.T);
		assume (0.000016667 >= (1.0 - 0.6072) * 0.000016667);
		// havoc new vars
		havoc buckboost.buckboost_template_1.t.new;
		havoc buckboost.buckboost_template_1.gt.new;
		havoc buckboost.buckboost_template_1.vc.new;
		havoc buckboost.buckboost_template_1.il.new;
		// assume assignment condition
		// assume (buckboost.buckboost_template_1.t.new == 0.0 && buckboost.buckboost_template_1.gt.new == buckboost.buckboost_template_1.gt && buckboost.buckboost_template_1.vc.new == buckboost.buckboost_template_1.vc && buckboost.buckboost_template_1.il.new == buckboost.buckboost_template_1.il);
		assume (0.000016667 == 0.0 && buckboost.buckboost_template_1.gt.new == buckboost.buckboost_template_1.gt && buckboost.buckboost_template_1.vc.new == buckboost.buckboost_template_1.vc && buckboost.buckboost_template_1.il.new == buckboost.buckboost_template_1.il);
		// assign new variable values
		buckboost.buckboost_template_1.t := buckboost.buckboost_template_1.t.new;
		buckboost.buckboost_template_1.gt := buckboost.buckboost_template_1.gt.new;
		buckboost.buckboost_template_1.vc := buckboost.buckboost_template_1.vc.new;
		buckboost.buckboost_template_1.il := buckboost.buckboost_template_1.il.new;
		goto buckboost.buckboost_template_1.charging;
	}
	if (*) {
		assume (buckboost.buckboost_template_1.il <= 0.0);
		// havoc new vars
		havoc buckboost.buckboost_template_1.t.new;
		havoc buckboost.buckboost_template_1.gt.new;
		havoc buckboost.buckboost_template_1.vc.new;
		havoc buckboost.buckboost_template_1.il.new;
		// assume assignment condition
		// assume (buckboost.buckboost_template_1.t.new == 0.0 && buckboost.buckboost_template_1.gt.new == buckboost.buckboost_template_1.gt && buckboost.buckboost_template_1.vc.new == buckboost.buckboost_template_1.vc && buckboost.buckboost_template_1.il.new == buckboost.buckboost_template_1.il);
		assume (0.000016667 == 0.0 && buckboost.buckboost_template_1.gt.new == buckboost.buckboost_template_1.gt && buckboost.buckboost_template_1.vc.new == buckboost.buckboost_template_1.vc && buckboost.buckboost_template_1.il.new == buckboost.buckboost_template_1.il);
		// assign new variable values
		buckboost.buckboost_template_1.t := buckboost.buckboost_template_1.t.new;
		buckboost.buckboost_template_1.gt := buckboost.buckboost_template_1.gt.new;
		buckboost.buckboost_template_1.vc := buckboost.buckboost_template_1.vc.new;
		buckboost.buckboost_template_1.il := buckboost.buckboost_template_1.il.new;
		goto buckboost.buckboost_template_1.discontinuous;
	}
	goto ~SX2B.end;

	// End
~SX2B.end:
	// Nothing to do here!

}
