function Transition_SpaceExToStateflow(sF,chart,base,variables,out_vars,idToLocation,opt_display_guard)
%
% ------------------------------------------------------------------------------
% author: Luan Viet Nguyen
% ------------------------------------------------------------------------------

    % position parmameters
    width = 150;
    heigth = 150;
    
    % iterate over transitions    
    for i_trans = 0 : base.getTransitionCount() - 1
        trans = base.getTransition(i_trans);
        transitions(i_trans + 1) = trans;
        % print the guard
        if opt_display_guard
            ['Guard: ', expr_SpaceExToStateflow(trans.getGuard, EEqualityHandling.doubleEq)]
        end

        % from location
        idToLocation( trans.getSource );
        TransitionPointer = Stateflow.Transition(chart);
        TransitionPointer.Source = sF(trans.getSource);
        % to location
        idToLocation( trans.getTarget );
        TransitionPointer.Destination = sF(trans.getTarget);

        % set the position of transition
        if base.getTransitionCount() == 1
            TransitionPointer.SourceOClock = 0;
            TransitionPointer.DestinationOClock = 3;
            TransitionPointer.MidPoint = [500 125];
            TransitionPointer.LabelPosition = [450 100 0 0]; 
        else
            TransitionPointer.SourceOClock = (i_trans + 1)*6;
            TransitionPointer.DestinationOClock = (i_trans + 1)*6;
        end
        % add the guard into SLSF model
        if ~isempty(trans.getGuard)
            [Guard_Label,Guard,Assignment] = Guard_SpaceExToStateflow(trans.getAssignment,expr_SpaceExToStateflow(trans.getGuard, EEqualityHandling.doubleEq),variables,out_vars);
        else
            [Guard_Label,Guard,Assignment] = Guard_SpaceExToStateflow(trans.getAssignment,'',variables,out_vars);
        end
        TransitionPointer.LabelString = Guard_Label;
        pos = TransitionPointer.LabelPosition;
        pos(1) = pos(1)+ 0.5*width;
        pos(2) = pos(2)- heigth/5;
        TransitionPointer.LabelPosition = pos;
    end
end