function [out] = adj_matrix_randgen_hybridautomaton(opt_guard_selfloop,num_loc)
%
% ------------------------------------------------------------------------------
% author: Luan Viet Nguyen
% ------------------------------------------------------------------------------
% randomly generate adjacency matrix for creating the discrete structure of a
% hybrid automaton
    regenerate_adj_matrix = 1;
    if num_loc == 1
        adjacency_matrix = 1;
    else
        while regenerate_adj_matrix == 1    
            %num_trans = 0;
            regenerate_adj_matrix = 0;
            adjacency_matrix = randi([0,1],num_loc);
            for i_loc = 1 : num_loc %
                for j_loc = 1 : length(adjacency_matrix)
                    if opt_guard_selfloop == 0
                        if i_loc == j_loc % transition from location i_loc to j_loc
                           adjacency_matrix(i_loc, j_loc) = 0;
                        end
                    end
                end  
                % ensure at least one out going transition
                if sum(adjacency_matrix(i_loc,:)) == 0
                    regenerate_adj_matrix = 1;
                end
            end
            % ensure at least one in going transition
            for i_loc = 1 : num_loc %
                if sum(adjacency_matrix(:,i_loc)) == 0
                        regenerate_adj_matrix = 1;
                end
            end    
        end 
    end
    out = adjacency_matrix;
end