function [iteration, tElapsed] = batch_ball(num_loc,num_var)

%
% ------------------------------------------------------------------------------
% author: Luan Viet Nguyen
% ------------------------------------------------------------------------------

    % e.g run [iteration, generation_time] = batch_ball(1,2) to generate
    % the model whose behavior is similar to boucing ball system     
    
    opt_debug = 0;

    % keep track the number of execution to achieve the desired matrix
    tStart=tic;
    match_bouncing_ball = 0;
    iteration = 0;
    
    dynamic = [];
    %

    while sum(find(eig(dynamic)))>0 || sum(find(dynamic))==0 || match_bouncing_ball == 0
        [dynamic, doc] = randgen_hybridautomaton(num_loc,num_var,'-mg','-s','-rd','-ci','-sr');
        %[dynamic, doc] = randgen_hybridautomaton(num_loc,num_var,'-s','-z','-ci','-sr');
        clear base;
        base = doc.getComponent(0);
        for i_loc = 0 : base.getLocationCount() - 1
            loc = base.getLocation(i_loc);
            invariant =  expr_SpaceExToStateflow(loc.getInvariant,EEqualityHandling.singleEq);
            if opt_debug
                %['Flow: ', expr_SpaceExToStateflow(loc.getFlow,EEqualityHandling.singleEq)]
                ['Invariant: ', invariant]
            end
        end    
        for i_trans = 0 : base.getTransitionCount() - 1
            trans = base.getTransition(i_trans);
            guard = expr_SpaceExToStateflow(trans.getGuard, EEqualityHandling.doubleEq);
            reset = expr_SpaceExToStateflow(trans.getAssignment,EEqualityHandling.singleEq);
            if opt_debug
                ['Guard: ', guard]
                ['Assigment: ', reset]
            end
        end
        %check invariant
        match_bouncing_ball = 0;
        match_invariant = 0;
        if isempty(strfind(invariant,'&')) && isempty(strfind(invariant,'<='))
            match_invariant = 1;
        end     
        match_guard = 0;
        % regular expression for the guard of bouncing ball '\w*<=(-)?(\d*)(.)?\d+'
        % split guard into cell array
        guard_element = regexp(guard, '\w*<=(-)?(\d*)(.)?\d+', 'match');
        if length(guard_element) == num_var
            match_guard = 1;
        end
        match_reset = 0;
        reset_element = strsplit(reset,'&&');
        % regular expression for the reset of bouncing ball '\w*=(0)?(0-|-)?(\d*)(.)?\d+(\*\w+)?'
        reset_cons_element = regexp(reset,'\w*=(0)?-(\d*)(.)?\d+(\*\w+)?', 'match');
        match_reset_element_counter = 0;
        if length(reset_element) == length(reset_cons_element)
            for i = 1: length(reset_element)   
                if strcmp(reset_cons_element{i},reset_element{i}) == 1
                    match_reset_element_counter = match_reset_element_counter + 1;
                end
            end
        end
        if match_reset_element_counter == length(reset_element);
           match_reset = 1; 
        end    
        if match_invariant == 1 &&  match_guard == 1 && match_reset == 1
           match_bouncing_ball = 1;
        end   
        iteration = iteration + 1;
    end    
    tElapsed=toc(tStart);
end