function [out] = expr_SpaceExToStateflow(formula, equality_handling)
%
% ------------------------------------------------------------------------------
% author: Luan Viet Nguyen
% ------------------------------------------------------------------------------

    % todo: figure out how to import to avoid prefixing, using import did not work
    prefix = 'de.uni_freiburg.informatik.swt.sxhybridautomaton.formula.';
    
    if ~isempty(formula)
        if isa(formula,[prefix, 'Variable'])
            out = char(formula.get);
            if formula.isPrimed
                out = strcat(out, '''');
            end
        elseif isa(formula,[prefix, 'Constant'])
            out = char(formula);
        %elseif isa(formula,[prefix,'Operator']) || isa(formula,[prefix,'Operation'])
        elseif  isa(formula,[prefix,'Operation'])    
            left = formula.getLeft();
            right = formula.getRight();
            op = char(formula.getOperator.toString);
            switch op % TODO: case sensitivity?
                case 'EQUAL'
                    switch (equality_handling)
                        case EEqualityHandling.singleEq
                            opconv = '=';
                        case EEqualityHandling.doubleEq
                            opconv = '==';
                        case EEqualityHandling.interval
                            % interval (lhs - eps <= rhs && lhs + eps >= rhs)
                            lhs = expr_SpaceExToStateflow(left, EEqualityHandling.singleEq);
                            rhs = expr_SpaceExToStateflow(right, EEqualityHandling.singleEq);
                            out = strcat('(', lhs , ' - ', AuxVarMap.eps, ' <= ', rhs, ' && ', lhs , ' + ', AuxVarMap.eps, ' >= ', rhs ,')');       
                            return;
                    end
                case 'NOTEEQUAL'
                    opconv = '!=';
                case 'LESS'
                    opconv = '<';
                case 'GREATER'
                    opconv = '>';
                case 'LESSEQUAL'
                    opconv = '<=';
                case 'GREATEREQUAL'
                    opconv = '>=';
                case 'MULTIPLY'
                    opconv = '*';
                case 'DIVIDE'
                    opconv = '/';
                case 'ADD'
                    opconv = '+';
                case 'SUBTRACT'
                    opconv = '-';
                case 'AND'
                    opconv = '&&';
                case 'OR'
                    opconv = '||';
                otherwise
                    opconv = op;
            end
            % check the operation order by using a boolean printBraces  
            printBraces = false;
			parent = formula.getParent();
            if ~isempty(parent)
                printBraces = (formula.getOperator.getPriority(parent.getOperator()) < formula.getOperator.getPriority(formula.getOperator()));
            end
            if (printBraces) 
                out = strcat('(',expr_SpaceExToStateflow(left, equality_handling), ' ', opconv, ' ', expr_SpaceExToStateflow(right, equality_handling),')');       
            else 
                out = strcat(expr_SpaceExToStateflow(left, equality_handling), ' ', opconv, ' ', expr_SpaceExToStateflow(right, equality_handling));
            end
        else
            formula
            'other cases / error'
        end
    end
end