function [out] = flow_randgen_hybridautomaton(num_var,x_sys,random_matrix,opt_zero,opt_dwelltime)

%
% ------------------------------------------------------------------------------
% author: Luan Viet Nguyen
% ------------------------------------------------------------------------------
    % generated random flow dynamics in SpaceEx format
    opt_debug = 0;
    inv_max = 10;
    constant_matrix = zeros(num_var,1);
    if opt_zero == 1;
        constant_matrix(num_var,1) =  rand*randi([-20,-10],1,1);
        flows_all =  random_matrix*x_sys(:) + constant_matrix;
    else
        % create random constant random matrix
        constant_matrix = 2*inv_max*rand(num_var)*randi([0,1],num_var,1);
        flows_all =  random_matrix*x_sys(:) + constant_matrix;
    end    
    flow_final = '';
    for i_var = 1: num_var
        flow_correction = char(flows_all(i_var,:));
        % checking the flow starts with negative number or not
        % yes: adding zero to eleminate fomular parsing error
        % TODO: find a better way to handle this error
        if opt_debug
            ['flows_all: ', char(flows_all(i_var,:))];
        end
        if  strcmp(flow_correction(1),'-')
            flows = [char(x_sys(i_var)),'''= 0 ', char(vpa(flows_all(i_var,:),4))];
        else
            flows = [char(x_sys(i_var)),'''=',char(vpa(flows_all(i_var,:),4))];
        end
        if i_var == 1
            flow_final = [flow_final,flows];
        else
            flow_final = [flow_final,'&&',flows];
        end
    end
    if opt_dwelltime == 1
        flow_final = [flow_final,'&&','t''= 1'];
        out = flow_final;
    else
        % repeated code to avoid Too many output arguments error
        out = flow_final;
    end
end