function [constantNames] = getConstantValues_SpaceExToStateflow(model,chart,constantList,InitialConstant)
%
% ------------------------------------------------------------------------------
% author: Luan Viet Nguyen
% ------------------------------------------------------------------------------

    constantNames = '';
    for i_const =  0: constantList.size()-1
        constantNames{i_const+1} = constantList.getConstantByIndex(i_const).getName();
        sF_cons = Stateflow.Data(chart); 
        constantName = regexprep(char(constantNames{i_const+1}),'null','');
        sF_cons.Name = constantName;
        sF_cons.Scope = 'Constant';
        matchContant = 0; % check initial constant value from cfg file  
        for i = 1: length(InitialConstant)
            InitialConstant_temp = InitialConstant{i};
            if strcmp(regexp(InitialConstant_temp,'(\w+)=','match'),strcat(constantName,'='))
                sF_cons.Props.InitialValue = regexprep(InitialConstant{i},'(\w+)=','');
                if strcmpi(constantName,'tmax')
                    StopSimulation = regexprep(InitialConstant{i},'(\w+)=','');
                    % set the simulation stop time based on the value of tmax
                    set_param(model.Name, 'StopTime',StopSimulation);
                end    
                matchContant = 1;
            end 
        end 
        if matchContant == 0
            sF_cons.Props.InitialValue = num2str(constantList.getConstantByIndex(i_const).getValue());
            if strcmpi(constantName,'tmax')
                    StopSimulation = num2str(constantList.getConstantByIndex(i_const).getValue());
                    set_param(model.Name, 'StopTime',StopSimulation);
            end  
        end
    end
end