function [opt_guard_selfloop, opt_dwelltime,  opt_sanity_checking,opt_spaceExtoStateflow, opt_zero, opt_negative, opt_positive_negative,opt_negative_zero,...
          opt_postive_negative_zero, opt_positive_real,opt_negative_real,opt_imaginary,opt_random_dynamics,opt_constant_invariant,...
          opt_symbolic_invariant, opt_constant_reset,  opt_symbolic_reset, opt_multi_generation] = option_randgen_hybridautomaton(argument)
%
% ------------------------------------------------------------------------------
% author: Luan Viet Nguyen
% ------------------------------------------------------------------------------

    % add ouput options
    opt_guard_selfloop = 0;
    if  find(cellfun(@(s)strcmp(s,'-g'),argument))
        opt_guard_selfloop = 1;      % call randgen_hybridautomaton('-g') to generate RandHA included a self-loop guard implementation 
    end
    opt_dwelltime = 0;
    if  find(cellfun(@(s)strcmp(s,'-t'),argument))
        opt_dwelltime = 1;      % call randgen_hybridautomaton('-t') to generate RandHA with a dwell-time guard implementation
    end
    opt_sanity_checking = 0;
    if  find(cellfun(@(s)strcmp(s,'-s'),argument))
        opt_sanity_checking = 1;      % call randgen_hybridautomaton('-s') to generate RandHA with a global clock
    end
    opt_spaceExtoStateflow = 0;
    if  find(cellfun(@(s)strcmp(s,'-ss'),argument))
        opt_spaceExtoStateflow = 1;      % call randgen_hybridautomaton('-ss') to enable spaceExtoStateflow translation
    end
    opt_zero = 0;
    if  find(cellfun(@(s)strcmp(s,'-z'),argument))
        opt_zero = 1;      % call randgen_hybridautomaton('-z') to generate RandHA with a stable dynamics( zero eigenvalues )
    end
    opt_negative = 0;
    if  find(cellfun(@(s)strcmp(s,'-n'),argument))
        opt_negative = 1;      % call randgen_hybridautomaton('-n') to generate RandHA with a stable dynamics( negative eigenvalues )
    end
    opt_positive_negative = 0;
    if  find(cellfun(@(s)strcmp(s,'-pn'),argument))
        opt_positive_negative = 1;      % call randgen_hybridautomaton('-pn') to generate RandHA whose dynamics can be stable or unstable( positive and negative eigenvalues)
    end
    opt_negative_zero = 0;
    if  find(cellfun(@(s)strcmp(s,'-nz'),argument))
        opt_negative_zero = 1;      % call randgen_hybridautomaton('-nz') to generate RandHA with a stable dynamics( negative and zero eigenvalues)
    end
    opt_postive_negative_zero = 0;
    if  find(cellfun(@(s)strcmp(s,'-pnz'),argument))
        opt_postive_negative_zero = 1;      % call randgen_hybridautomaton('-pnz') to generate RandHA that is stable or unstable dynamics( combination of positive, negative and zero eigenvalues)
    end
    opt_positive_real = 0;
    if  find(cellfun(@(s)strcmp(s,'-pr'),argument))
        opt_positive_real = 1;      % call randgen_hybridautomaton('-pr') to generate RandHA with a stable dynamics( postive real part eigenvalues)
    end
    opt_negative_real= 0;
    if  find(cellfun(@(s)strcmp(s,'-nr'),argument))
        opt_negative_real = 1;      % call randgen_hybridautomaton('-nr') to generate RandHA with a stable dynamics( negative real part eigenvalues)
    end
    opt_imaginary = 0;
    if  find(cellfun(@(s)strcmp(s,'-i'),argument))
        opt_imaginary = 1;      % call randgen_hybridautomaton('-i') to generate RandHA with a stable dynamics( only imaginary eigenvalues )
    end
    opt_random_dynamics = 0;
    if  find(cellfun(@(s)strcmp(s,'-rd'),argument))
        opt_random_dynamics = 1;      % call randgen_hybridautomaton('-rd') to generate RandHA with a random dynamics
    end
    % add constant invariant
    opt_constant_invariant = 0;
    if  find(cellfun(@(s)strcmp(s,'-ci'),argument))
        opt_constant_invariant = 1;      % call randgen_hybridautomaton('-ci') to create a constant invariant
    end
    % add symbolic invariant
    opt_symbolic_invariant = 0;
    if  find(cellfun(@(s)strcmp(s,'-si'),argument))
        opt_symbolic_invariant = 1;      % call randgen_hybridautomaton('-si') to create a symbolic invariant
    end
    %
    opt_constant_reset = 0;
    if  find(cellfun(@(s)strcmp(s,'-cr'),argument))
        opt_constant_reset = 1;      % call randgen_hybridautomaton('-cr') to generate RandHA with a reset to constant
    end
    opt_symbolic_reset = 0;
    if  find(cellfun(@(s)strcmp(s,'-sr'),argument))
        opt_symbolic_reset = 1;      % call randgen_hybridautomaton('-sr') to generate RandHA with a reset to a fucntion of variables
    end
    opt_multi_generation = 0;
    if  find(cellfun(@(s)strcmp(s,'-mg'),argument))
        opt_multi_generation = 1;      % call randgen_hybridautomaton('-mg') to save multiple examples generation in specific folder
    end
       