function [out] = reset_randgen_hybridautomaton(x_sys,i_loc,num_var, opt_dwelltime,opt_zero,opt_constant_reset, opt_symbolic_reset,rand_cons_invariant) 
%
% ------------------------------------------------------------------------------
% author: Luan Viet Nguyen
% ------------------------------------------------------------------------------

    % generate random reset for each transition    
    reset_min = 1;
    reset_max = 10; 
    rand_cons_reset = rand_cons_invariant;
    reset = '';
    if opt_dwelltime == 1
        reset = 't==0';    
        if opt_constant_reset
            for i_var = 1: num_var
                reset = [reset,'&&',char(x_sys(i_var)),'=',num2str(randi([reset_min,reset_max]))];
            end
        elseif opt_symbolic_reset            
            for i_var = 1: num_var
                if opt_negative_invariant || opt_negative
                    reset = [reset,'&&',char(x_sys(i_var)),'=',char(x_sys*randi([0,1],num_var,1)+randi([reset_min,reset_max]))]; 
                else
                    reset = [reset,'&&',char(x_sys(i_var)),'=',char(x_sys*randi([0,1],num_var,1))];
                end
            end
        end  
    else
        if  opt_zero
            reset = [char(x_sys(1)),'=',num2str(rand_cons_reset(i_loc,1))];
            for i_var = 2: num_var
                reset = [reset,'&&',char(x_sys(i_var)),'=',char(vpa((-1+2*rand)*x_sys(i_var),4))];
            end              
        else
            if opt_constant_reset
                reset = [char(x_sys(1)),'=',num2str(randi([reset_min,reset_max/2]))];
                for i_var = 2: num_var
                    reset = [reset,'&&',char(x_sys(i_var)),'=',num2str(randi([reset_min,reset_max/2]))];
                end
            elseif opt_symbolic_reset  
                % TODO: Fixed in a smartter way
                    reset_sym_equation = char(vpa(x_sys*vpa(rand(num_var)*randi([-1,0],num_var,1),4),4));
                    if  strcmp(reset_sym_equation(1),'-')
                        reset_sym_equation = ['0',reset_sym_equation];
                    end      
                    reset = [ char(x_sys(1)),'=',reset_sym_equation];
                for i_var = 2: num_var
                    reset_sym_equation = char(vpa(x_sys*vpa(rand(num_var)*randi([-2,-1],num_var,1),4),4));
                    if  strcmp(reset_sym_equation(1),'-')
                        reset_sym_equation = ['0',reset_sym_equation];
                    end  
                    reset = [reset,'&&',char(x_sys(i_var)),'=',reset_sym_equation];
                end
            end 
        end
    end
    out = reset;
end